<?php

class ModelModuleNe extends Model
{

    public function install()
    {

        if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
            $store_url = (defined('HTTPS_CATALOG') ? HTTPS_CATALOG : HTTP_CATALOG);
        } else {
            $store_url = HTTP_CATALOG;
        }

        $ne_subscribe_box = <<<SUBSCRIBE_BOX
  CREATE TABLE IF NOT EXISTS `ne_subscribe_box` (
    `subscribe_box_id` int(11) NOT NULL auto_increment,
    `name` varchar(255) NOT NULL,
    `status` tinyint(1) NOT NULL,
    `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    `data` text NOT NULL,
    PRIMARY KEY  (`subscribe_box_id`)
  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
SUBSCRIBE_BOX;

        $this->db->query(str_replace('ne_subscribe_box', DB_PREFIX . 'ne_subscribe_box', $ne_subscribe_box));

        $ne_language_map = <<<LANG_MAP
CREATE TABLE IF NOT EXISTS `ne_language_map` (
  `c_email` varchar(255) NOT NULL,
  `language_code` varchar(5) NOT NULL,
  PRIMARY KEY  (`c_email`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
LANG_MAP;

        $this->db->query(str_replace('ne_language_map', DB_PREFIX . 'ne_language_map', $ne_language_map));

        $ne_blacklist = <<<BLACKLIST
CREATE TABLE IF NOT EXISTS `ne_blacklist` (
  `blacklist_id` int(11) NOT NULL auto_increment,
  `email` varchar(255) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`blacklist_id`),
  UNIQUE KEY `email` (`email`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
BLACKLIST;

        $this->db->query(str_replace('ne_blacklist', DB_PREFIX . 'ne_blacklist', $ne_blacklist));

        $ne_clicks = <<<CLICKS
CREATE TABLE IF NOT EXISTS `ne_clicks` (
  `clicks_id` int(11) NOT NULL auto_increment,
  `stats_personal_id` int(11) NOT NULL,
  `url` varchar(400) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `kind` varchar(255) NOT NULL,
  PRIMARY KEY  (`clicks_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
CLICKS;

        $this->db->query(str_replace('ne_clicks', DB_PREFIX . 'ne_clicks', $ne_clicks));

        $ne_draft = <<<DRAFT
CREATE TABLE IF NOT EXISTS `ne_draft` (
  `draft_id` int(11) NOT NULL auto_increment,
  `to` varchar(255) NOT NULL,
  `subject` varchar(400) NOT NULL,
  `message` longtext NOT NULL,
  `text_message` longtext NOT NULL,
  `text_message_products` tinyint(1) NOT NULL,
  `store_id` int(11) NOT NULL,
  `attachments_id` int(11) NOT NULL,
  `template_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `currency` varchar(3) NOT NULL,
  `defined` tinyint(1) NOT NULL,
  `special` tinyint(1) NOT NULL,
  `latest` tinyint(1) NOT NULL,
  `popular` tinyint(1) NOT NULL,
  `categories` tinyint(1) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `customer_group_id` int(11) NOT NULL,
  `customer_group_only_subscribers` tinyint(1) NOT NULL,
  `only_selected_language` tinyint(1) NOT NULL,
  `customer` text NOT NULL,
  `affiliate` text NOT NULL,
  `product` text NOT NULL,
  `defined_products` text NOT NULL,
  `defined_products_more` text NOT NULL,
  `defined_categories` text NOT NULL,
  `skip_out_of_stock` text NOT NULL,
  `defined_category_limit` int(11) NOT NULL,
  `defined_category_sort` varchar(255) NOT NULL,
  `defined_category_order` tinyint(1) NOT NULL,
  `marketing_list` text NOT NULL,
  PRIMARY KEY  (`draft_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
DRAFT;

        $this->db->query(str_replace('ne_draft', DB_PREFIX . 'ne_draft', $ne_draft));

        $ne_history = <<<HISTORY
CREATE TABLE IF NOT EXISTS `ne_history` (
  `history_id` int(11) NOT NULL auto_increment,
  `public_id` varchar(32) NOT NULL,
  `subject` varchar(400) NOT NULL,
  `message` longtext NOT NULL,
  `text_message` longtext NOT NULL,
  `text_message_products` tinyint(1) NOT NULL,
  `to` varchar(255) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `store_id` int(11) NOT NULL,
  `template_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  PRIMARY KEY  (`history_id`),
  UNIQUE KEY `public_id` (`public_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
HISTORY;

        $this->db->query(str_replace('ne_history', DB_PREFIX . 'ne_history', $ne_history));

        $ne_marketing = <<<MARKETING
CREATE TABLE IF NOT EXISTS `ne_marketing` (
  `marketing_id` int(11) NOT NULL auto_increment,
  `firstname` varchar(32) NOT NULL,
  `lastname` varchar(32) NOT NULL,
  `email` varchar(255) NOT NULL,
  `subscribed` int(1) NOT NULL,
  `code` varchar(255) NOT NULL,
  `store_id` int(11) NOT NULL,
  PRIMARY KEY  (`marketing_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
MARKETING;

        $this->db->query(str_replace('ne_marketing', DB_PREFIX . 'ne_marketing', $ne_marketing));

        $this->db->query("ALTER TABLE `" . DB_PREFIX . "ne_marketing` ADD UNIQUE `email` (`email`, `store_id`)");

        $ne_marketing_to_list = <<<MARKETINGLIST
CREATE TABLE IF NOT EXISTS `ne_marketing_to_list` (
  `marketing_to_list_id` int(11) NOT NULL auto_increment,
  `marketing_id` int(11) NOT NULL,
  `marketing_list_id` int(11) NOT NULL,
  PRIMARY KEY  (`marketing_to_list_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
MARKETINGLIST;

        $this->db->query(str_replace('ne_marketing_to_list', DB_PREFIX . 'ne_marketing_to_list', $ne_marketing_to_list));

        $ne_queue = <<<QUEUE
CREATE TABLE IF NOT EXISTS `ne_queue` (
  `queue_id` int(11) NOT NULL auto_increment,
  `history_id` int(11) NOT NULL,
  `email` varchar(255) NOT NULL,
  `firstname` varchar(255) NOT NULL,
  `lastname` varchar(255) NOT NULL,
  `locked` tinyint(1) NOT NULL default '0',
  `retries` int(11) NOT NULL,
  PRIMARY KEY  (`queue_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
QUEUE;

        $this->db->query(str_replace('ne_queue', DB_PREFIX . 'ne_queue', $ne_queue));

        $ne_schedule = <<<SCHEDULE
CREATE TABLE IF NOT EXISTS `ne_schedule` (
  `schedule_id` int(11) NOT NULL auto_increment,
  `active` tinyint(1) NOT NULL,
  `name` varchar(255) NOT NULL,
  `date` date NOT NULL,
  `date_next` date NOT NULL,
  `time` int(2) NOT NULL,
  `day` tinyint(1) NOT NULL,
  `frequency` tinyint(1) NOT NULL,
  `store_id` int(11) NOT NULL,
  `template_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `currency` varchar(3) NOT NULL,
  `to` varchar(255) NOT NULL,
  `subject` varchar(400) NOT NULL,
  `message` longtext NOT NULL,
  `text_message` longtext NOT NULL,
  `text_message_products` tinyint(1) NOT NULL,
  `random` tinyint(1) NOT NULL,
  `random_count` int(11) NOT NULL,
  `marketing_list` text NOT NULL,
  `defined` tinyint(1) NOT NULL,
  `defined_products` text NOT NULL,
  `defined_products_more` text NOT NULL,
  `categories` tinyint(1) NOT NULL,
  `defined_categories` text NOT NULL,
  `skip_out_of_stock` text NOT NULL,
  `defined_category_limit` int(11) NOT NULL,
  `defined_category_sort` varchar(255) NOT NULL,
  `defined_category_order` tinyint(1) NOT NULL,
  `special` tinyint(1) NOT NULL,
  `latest` tinyint(1) NOT NULL,
  `popular` tinyint(1) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `recurrent` tinyint(1) NOT NULL,
  `customer_group_id` int(11) NOT NULL,
  `customer_group_only_subscribers` tinyint(1) NOT NULL,
  `only_selected_language` tinyint(1) NOT NULL,
  `customer` text NOT NULL,
  `affiliate` text NOT NULL,
  `product` text NOT NULL,
  PRIMARY KEY  (`schedule_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
SCHEDULE;

        $this->db->query(str_replace('ne_schedule', DB_PREFIX . 'ne_schedule', $ne_schedule));

        $ne_stats = <<<STATS
CREATE TABLE IF NOT EXISTS `ne_stats` (
  `stats_id` int(11) NOT NULL auto_increment,
  `history_id` int(11) NOT NULL,
  `queue` int(11) NOT NULL,
  `recipients` int(11) NOT NULL,
  `views` int(11) NOT NULL,
  PRIMARY KEY  (`stats_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
STATS;

        $this->db->query(str_replace('ne_stats', DB_PREFIX . 'ne_stats', $ne_stats));

        $ne_stats_personal = <<<STATSPERSONAL
CREATE TABLE IF NOT EXISTS `ne_stats_personal` (
  `stats_personal_id` int(11) NOT NULL auto_increment,
  `history_id` int(11) NOT NULL,
  `email` varchar(255) NOT NULL,
  `views` int(11) NOT NULL default '0',
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `success` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`stats_personal_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
STATSPERSONAL;

        $this->db->query(str_replace('ne_stats_personal', DB_PREFIX . 'ne_stats_personal', $ne_stats_personal));

        $ne_stats_personal_views = <<<STATSPERSONALVIEWS
CREATE TABLE IF NOT EXISTS `ne_stats_personal_views` (
  `stats_personal_views_id` int(11) NOT NULL auto_increment,
  `stats_personal_id` int(11) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`stats_personal_views_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
STATSPERSONALVIEWS;

        $this->db->query(str_replace('ne_stats_personal_views', DB_PREFIX . 'ne_stats_personal_views', $ne_stats_personal_views));

        $ne_template = <<<TEMPLATE
CREATE TABLE IF NOT EXISTS `ne_template` (
  `template_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `uri` varchar(255) NOT NULL,
  `datetime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `product_image_width` int(11) NOT NULL,
  `product_image_height` int(11) NOT NULL,
  `product_show_prices` tinyint(1) NOT NULL,
  `product_show_savings` tinyint(1) NOT NULL,
  `product_description_length` int(11) NOT NULL,
  `product_cols` int(11) NOT NULL,
  `heading_color` varchar(7) NOT NULL,
  `heading_style` text NOT NULL,
  `product_name_color` varchar(7) NOT NULL,
  `product_name_style` text NOT NULL,
  `product_model_color` varchar(7) NOT NULL,
  `product_model_style` text NOT NULL,
  `product_price_color` varchar(7) NOT NULL,
  `product_price_style` text NOT NULL,
  `product_price_color_special` varchar(7) NOT NULL,
  `product_price_style_special` text NOT NULL,
  `product_price_color_when_special` varchar(7) NOT NULL,
  `product_price_style_when_special` text NOT NULL,
  `product_description_color` varchar(7) NOT NULL,
  `product_description_style` text NOT NULL,
  `product_savings_color` varchar(7) NOT NULL,
  `product_savings_style` text NOT NULL,
  `custom_css` longtext NOT NULL,
  `specials_count` int(11) NOT NULL,
  `latest_count` int(11) NOT NULL,
  `popular_count` int(11) NOT NULL,
  PRIMARY KEY  (`template_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
TEMPLATE;

        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template));

        $this->editSettingValue('ne', 'ne_update_hash', '');

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(1, 'По умолчанию', 'default', '2012-06-19 18:10:56', 140, 140, 1, 0, 100, 4, '#222222', 'background-color:#b7e6f8;padding-left:15px;font-size:16px;font-family:Arial,Helvetica,sans-serif;padding-top:10px;padding-bottom:10px;text-transform:uppercase;', '#222222', 'font-size:12px;', '#999999', '', '#990000', 'padding-bottom:6px; font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(2, 'Рождество', 'christmas', '2012-09-01 00:00:00', 140, 140, 1, 0, 100, 4, '#222222', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/productbg.png) repeat-x;padding-left:15px;font-size:16px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;font-weight:bold;color:#fff;vertical-align:top;padding-top:18px;padding-bottom:2px;', '#222222', 'font-size:20px;text-decoration:none;', '#000000', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#666666', 'padding-bottom:6px;font-size:12px;', '#666666', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(3, 'Строгий', 'generic', '2012-09-02 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background: url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/generic/images/product.jpg) repeat-x;padding-left:15px;font-size:16px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:6px;padding-bottom:2px;', '#222222', 'font-size:20px;text-decoration:none;', '#000000', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(4, 'Хэллоуин', 'halloween', '2012-09-03 00:00:00', 140, 140, 1, 0, 100, 4, '#000000', 'padding-left:15px;font-size:16px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:30px;padding-bottom:2px;', '#000000', 'font-size:20px;text-decoration:none;', '#ffffff', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#ffffff', 'padding-bottom:6px;font-size:12px;', '#ffffff', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(5, 'Драгоценности', 'jewels', '2012-09-04 00:00:00', 140, 140, 1, 0, 100, 4, '#d5494c', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/jewels/images/product.jpg) repeat-x;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:26px;padding-bottom:12px;text-align:center;font-family:\'Times New Roman\';', '#222222', 'font-size:20px;text-decoration:none;', '#d5494c', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(6, 'Пасха', 'easter', '2012-09-05 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/easter/images/product.jpg) repeat-x;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:6px;padding-bottom:26px;text-align:center;', '#222222', 'font-size:20px;text-decoration:none;', '#000000', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(7, 'Новый год', 'newyear', '2012-09-06 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/newyear/images/product.jpg) no-repeat #fff;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:6px;padding-bottom:26px;text-align:center;', '#000000', 'font-size:20px;text-decoration:none;', '#fa4403', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(8, 'Спорт', 'sports', '2012-09-07 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/sports/images/product.jpg) repeat-x;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:10px;padding-bottom:5px;text-align:center;', '#000000', 'font-size:20px;text-decoration:none;', '#000000', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(9, 'Лето', 'summer', '2012-09-08 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background:#f77341;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:10px;padding-bottom:8px;text-align:center;', '#ffffff', 'font-size:20px;text-decoration:none;', '#eeeeee', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#eeeeee', 'padding-bottom:6px;font-size:12px;', '#ffffff', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(10, 'Техника', 'tech', '2012-09-09 00:00:00', 140, 140, 1, 0, 100, 4, '#222222', 'background:#00bae0;padding:15px;font-weight:bold;color:#fff;font-size:16px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;', '#ffffff', 'font-size:20px;text-decoration:none;', '#ffffff', '', '#01404f', 'padding-bottom:6px;font-size:18px;', '#01404f', 'padding-bottom:6px;font-size:18px;', '#f0f0f0', 'padding-bottom:6px;font-size:12px;', '#f0f0f0', 'font-size:12px;', '#01404f', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_db = <<<TEMPLATEDB
INSERT INTO `ne_template` (`template_id`, `name`, `uri`, `datetime`, `product_image_width`, `product_image_height`, `product_show_prices`, `product_show_savings`, `product_description_length`, `product_cols`, `heading_color`, `heading_style`, `product_name_color`, `product_name_style`, `product_model_color`, `product_model_style`, `product_price_color`, `product_price_style`, `product_price_color_special`, `product_price_style_special`, `product_price_color_when_special`, `product_price_style_when_special`, `product_description_color`, `product_description_style`, `product_savings_color`, `product_savings_style`, `specials_count`, `latest_count`, `popular_count`) VALUES
(11, 'Благодарение', 'thanksgiving', '2012-09-10 00:00:00', 140, 140, 1, 0, 100, 4, '#ffffff', 'background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/thanksgiving/images/product.jpg) repeat-x #f1e8d3;padding-left:15px;font-size:20px;font-family:Arial,Helvetica,sans-serif;text-transform:uppercase;vertical-align:top;padding-top:16px;padding-bottom:14px;text-align:center;', '#222222', 'font-size:20px;text-decoration:none;', '#000000', '', '#990000', 'padding-bottom:6px;font-size:18px;', '#990000', 'padding-bottom:6px;font-size:18px;', '#999999', 'padding-bottom:6px;font-size:12px;', '#999999', 'font-size:12px;', '#990000', 'font-size:18px;', 8, 8, 8);
TEMPLATEDB;

        $ne_template_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_db);
        $this->db->query(str_replace('ne_template', DB_PREFIX . 'ne_template', $ne_template_db));

        $ne_template_data = <<<TEMPLATEDATA
CREATE TABLE IF NOT EXISTS `ne_template_data` (
  `template_data_id` int(11) NOT NULL auto_increment,
  `template_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` text NOT NULL,
  `text_message` text NOT NULL,
  `defined` varchar(255) NOT NULL,
  `special` varchar(255) NOT NULL,
  `latest` varchar(255) NOT NULL,
  `popular` varchar(255) NOT NULL,
  `categories` varchar(255) NOT NULL,
  `savings` varchar(255) NOT NULL,
  PRIMARY KEY  (`template_data_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
TEMPLATEDATA;

        $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data));

        $this->editSettingValue('ne', 'ne_version_hash', '');

        $language_data = $this->db->query("SELECT language_id FROM " . DB_PREFIX . "language")->rows;

        foreach ($language_data as $language) {

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 1, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n   &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n           &lt;tr&gt;\r\n              &lt;td style=&quot;color: rgb(157, 168, 183); font-size: 11px; padding-top: 10px; padding-right: 0px; padding-bottom: 10px; padding-left: 28px; text-align: center; &quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:none;color:rgb(121,159,196);&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n           &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:0px;padding-left:28px;&quot; valign=&quot;top&quot;&gt;\r\n                       {logo}&lt;/td&gt;\r\n                     &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:rgb(53,115,173);&quot;&gt;\r\n                         {date}&lt;/div&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:rgb(53,115,173);&quot;&gt;\r\n                         &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:rgb(53,115,173);&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:rgb(53,115,173);&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:rgb(53,115,173);&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                   &lt;/tr&gt;\r\n                 &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n           &lt;/tr&gt;\r\n           &lt;tr&gt;\r\n              &lt;td style=&quot;padding-left:25px;padding-right:25px;&quot;&gt;\r\n                &lt;hr color=&quot;#D4D4D4&quot; size=&quot;1&quot; /&gt;\r\n             &lt;/td&gt;\r\n           &lt;/tr&gt;\r\n           &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding-left:25px;padding-right:25px;&quot;&gt;\r\n               &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;width:700px;&quot; width=&quot;700&quot;&gt;\r\n                 &lt;tbody&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        &lt;p&gt;\r\n                         &lt;span style=&quot;color:#222;&quot;&gt;&lt;span style=&quot;font-size:14px;&quot;&gt;&lt;strong&gt;Заголовок сообщения&lt;/strong&gt;&lt;/span&gt;&lt;/span&gt;&lt;/p&gt;\r\n                       &lt;p&gt;\r\n                         &lt;span style=&quot;color:#222;&quot;&gt;Текст сообщения&lt;/span&gt;&lt;/p&gt;\r\n                     &lt;/td&gt;\r\n                   &lt;/tr&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        {defined}&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        {special}&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        {latest}&lt;/td&gt;\r\n                   &lt;/tr&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        {popular}&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                   &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding:0;&quot;&gt;\r\n                        {categories}&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                 &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n           &lt;/tr&gt;\r\n           &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:11px;color:rgb(157,168,183);padding-top:15px;padding-right:28px;padding-bottom:20px;padding-left: 28px;&quot;&gt;\r\n  Если вы больше не хотите получать нашу рассылку - отпишитесь &amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:rgb(121,159,196);&quot;&gt;здесь&lt;/a&gt;.&lt;/td&gt;\r\n           &lt;/tr&gt;\r\n         &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n   &lt;/tr&gt;\r\n &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n&lt;p&gt;\r\n &amp;nbsp;&lt;/p&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 2, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#f6ebcf;padding:0 15px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;color: #f24615; font-size: 11px; padding-top: 10px; padding-right: 0px; padding-bottom: 10px; padding-left: 28px; text-align: right; &quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#f24615&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td height=&quot;103&quot; style=&quot;background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/christmasbg.png) repeat-x center top;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:0px;padding-left:28px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#fff;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding:10px;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#F00; font-weight:bold;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/christmasheader.png&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px; font-size:14px; color:#000;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;&quot;&gt;\r\n                &amp;nbsp;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td height=&quot;103&quot; style=&quot;background: url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/christmasbg.png) repeat-x center top;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding-left:15px; padding-top:10px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff; font-weight:bold; font-size:18px; margin-bottom:5px;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot; font-size:14px;&quot;&gt;\r\n              &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px; padding-top:20px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/christmas/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot; color:#f24615; font-size:12px; text-align:right; padding-top:15px&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n      &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#f24615&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 3, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130); background:#59ca51;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot; background:#f7f7f7&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;color: #fff; font-size: 11px; padding-top: 10px; padding-right: 0px; padding-bottom: 10px; padding-left: 28px; text-align: right; background:#59ca51 &quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#fff&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td height=&quot;130&quot; style=&quot;background: #000 center top;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:0px;padding-left:28px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#fff;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding:10px; background:#fff;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#000; font-weight:bold;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#333;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/generic/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;background:#fff; padding-top:10px; padding-bottom:20px; font-size:14px; color:#000; padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;background: #000 center top;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding-left:15px; padding-top:10px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff; font-weight:bold; font-size:18px; margin-bottom:5px;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot; font-size:14px; padding-bottom:20px;&quot;&gt;\r\n                               &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px; padding-top:20px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/generic/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/generic/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;color:#fff; font-size:12px; text-align:right; padding-top:15px; background:#59ca51;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n      &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline; color:#fff;&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 4, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#000;color:#fff;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#000;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#838383;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#838383;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:10px;padding-left:28px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:10px;padding-left:0px;font-size:18px;color:#fff;&quot; valign=&quot;top&quot;&gt;\r\n                        {date}&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#f39a1a;font-weight:bold;padding-top:10px;padding-bottom:10px;font-family: Arial, Helvetica, sans-serif;padding-left:10px;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#f39a1a;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;&lt;span style=&quot;text-decoration:none;color:#f39a1a;&quot;&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#f39a1a;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;&lt;span style=&quot;text-decoration:none;color:#f39a1a;&quot;&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#f39a1a;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/halloween/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n           &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-bottom:20px;font-size:14px;color:#fff;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n           &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding:10px 0 10px 0px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:0px;&quot;&gt;\r\n                                        &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/halloween/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/halloween/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td class=&quot;text-align:left;padding-bottom:10px;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;color:#848484;font-size:12px;&quot;&gt;\r\n                   &lt;p style=&quot;margin:0;color:#848484;font-size:12px;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#848484;&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 5, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#d9d9d9;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#fff;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr style=&quot;background:#d9d9d9;&quot;&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#7d7c7c;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#7d7c7c;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;background:#fff;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:15px;padding-right:0px;padding-bottom:0px;padding-left:15px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:15px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#d5494c;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#d5494c;font-weight:bold;padding-left:10px;padding-top:10px;padding-bottom:10px;font-style:italic;font-family:trebuchet;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#7c7c7c;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#7c7c7c;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#7c7c7c;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;background:#D9D9D9;&quot; width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/jewels/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#d9d9d9;&quot;&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-top:10px;padding-bottom:20px;font-size:14px;color:#d5494d;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#d9d9d9;&quot;&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding:10px 0 10px 0px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#7c7c7c;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:0px;&quot;&gt;\r\n                                &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/jewels/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/jewels/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:12px;text-align:left;background:#d9d9d9;text-align:left;padding-bottom:10px;color:#7c7c7c;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;color:#7c7c7c;font-size:12px;&quot;&gt;\r\n                 &lt;p style=&quot;margin:0;color:#7c7c7c;font-size:12px;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#7c7c7c;&quot;&gt;по ссылке&lt;/a&gt;.&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 6, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#f5f5f5;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#f5f5f5;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#717171;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#717171;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:none;&quot;&gt;\r\n              &lt;td height=&quot;103&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:0px;padding-left:10px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#717171;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table style=&quot;padding-bottom:10px;&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#717171;font-weight:bold;padding-left:10px;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/easter/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-bottom:20px;font-size:14px;color:#000;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr height=&quot;88&quot; style=&quot;background:url({HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/easter/images/footerbg.jpg);&quot;&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding-left:15px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:20px;&quot;&gt;\r\n  &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:15px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/easter/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/easter/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:12px;text-align:left;padding-top:0px;background:none;color:#717171;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#717171;&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 7, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#2e2929;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#fa4403;color:#fff;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr style=&quot;background:#2e2929;&quot;&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#7f7f7f;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#7f7f7f;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:20px;&quot; width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:0px;padding-left:10px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; valign=&quot;top&quot; width=&quot;250&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#fff;background:#c73d0d;padding:15px;min-width:250px;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#fff;font-weight:bold;padding-top:10px;padding-bottom:10px;font-family: Arial, Helvetica, sans-serif;padding-left:10px;font-size:18px;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#000;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;&lt;span style=&quot;text-decoration:none;color:#000;&quot;&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#000;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;&lt;span style=&quot;text-decoration:none;color:#000;&quot;&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#000;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/newyear/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-bottom:20px;font-size:14px;color:#fff;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fff;color:#000;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fff;color:#000;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fff;color:#000;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fff;color:#000;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fff;color:#000;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#fa4403;padding-left:10px;&quot;&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding:10px 0 10px 10px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:0px;&quot;&gt;\r\n                             &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/newyear/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/newyear/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#2e2929;&quot;&gt;\r\n              &lt;td style=&quot;font-size:12px;text-align:right;padding-bottom:10px;padding-top:10px;color:#848484;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n                          &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#848484;&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 8, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#000;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#000;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#b6b6b6;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#b6b6b6;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#df5845;&quot;&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:15px;padding-left:10px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#fff;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#fff;font-weight:bold;padding-top:10px;padding-bottom:10px;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#b5b5b5;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#b5b5b5;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#b5b5b5;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/sports/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-bottom:20px;font-size:14px;color:#fff;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;color:#fff;background:#f7f7f7;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;color:#fff;background:#f7f7f7;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;color:#fff;background:#f7f7f7;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;color:#fff;background:#f7f7f7;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;color:#fff;background:#f7f7f7;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#df5845;&quot;&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding:20px 0 20px 10px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#fff;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:0px;&quot;&gt;\r\n                    &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/sports/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/sports/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:12px;text-align:left;padding-top:10px;padding-bottom:10px;background:none;text-align:right;color:#b4b4b4;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n                          &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#b4b4b4;&quot;&gt;по ссылке&lt;/a&gt;.&lt;br /&gt;\r\n                  &amp;nbsp;&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 9, {language_id}, 'Тема вашей рассылки', '&lt;table border=&quot;0&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; border=&quot;0&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial, Helvetica, sans-serif;color:#fff;font-size:12px;&quot; width=&quot;700&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#fac169;text-align:right;padding-top:10px;font-size:11px;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма, &lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#fac169;text-align:right;padding-top:10px;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;padding:15px 0 15px 10px;&quot;&gt;\r\n                {logo}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#62bc0f;&quot; valign=&quot;middle&quot;&gt;\r\n              &lt;td style=&quot;font-size:17px;font-weight:bold;padding:40px 0 40px 10px;color:#fff;&quot; width=&quot;352&quot;&gt;\r\n                Рассылка магазина&lt;/td&gt;\r\n              &lt;td width=&quot;348&quot;&gt;\r\n                &lt;div style=&quot;text-align:right;font-size:15px;margin-bottom:10px;margin-right:10px;color:#cc482f;&quot;&gt;\r\n                  {date}&lt;/div&gt;\r\n                &lt;div style=&quot;color:#34610b;text-align:right;text-decoration:none;margin-right:10px;&quot;&gt;\r\n                  &lt;a href=&quot;{subscribe_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;&lt;span&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;&lt;span&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;padding:10px 0;&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/summer/images/header.jpg&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#cc3817;padding:10px 0 15px 0;font-size:14px;&quot;&gt;\r\n                Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#42abf7;&quot; valign=&quot;middle&quot;&gt;\r\n              &lt;td&gt;\r\n                &lt;div style=&quot;font-size:20px;font-weight:bold;margin-top:20px;color:#fff;margin-left:10px;&quot;&gt;\r\n                  Название магазина&lt;/div&gt;\r\n                &lt;div style=&quot;color:#fff;text-decoration:none;margin-left:10px;margin-bottom:20px;&quot;&gt;\r\n                             &lt;/td&gt;\r\n              &lt;td style=&quot;text-align:right;padding-right:10px;&quot;&gt;\r\n                &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/summer/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt;&lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/summer/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;text-decoration:none;font-size:12px;&quot;&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#138ca9;text-align:right;padding:10px 0;&quot;&gt;\r\n                         Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;color:#138ca9;text-decoration:underline;&quot;&gt;по ссылке.&lt;/a&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 10, {language_id}, 'Тема вашей рассылки', '&lt;table border=&quot;0&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#01404f;padding:0 10px;color:#fff;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; border=&quot;0&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial, Helvetica, sans-serif;color:#fff;font-size:12px;&quot; width=&quot;700&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#138ca9;text-align:right;padding-top:10px;font-size:11px;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма, &lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#138ca9;text-align:right;padding-top:10px;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;padding:15px 0;&quot;&gt;\r\n                {logo}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#62bc0f;&quot; valign=&quot;middle&quot;&gt;\r\n              &lt;td style=&quot;font-size:17px;font-weight:bold;padding:40px 0 40px 10px;color:#fff;&quot; width=&quot;352&quot;&gt;\r\n                Рассылка магазина&lt;/td&gt;\r\n              &lt;td width=&quot;348&quot;&gt;\r\n                &lt;div style=&quot;text-align:right;font-size:15px;margin-bottom:10px;margin-right:10px;color:#fff;&quot;&gt;\r\n                  {date}&lt;/div&gt;\r\n                &lt;div style=&quot;color:#34610b;text-align:right;text-decoration:none;margin-right:10px;&quot;&gt;\r\n                  &lt;a href=&quot;{subscribe_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;&lt;span&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;&lt;span&gt;|&lt;/span&gt;&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;color:#34610b;text-align:right;text-decoration:none;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;padding:10px 0;&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/tech/images/background.jpg&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#fff;padding:10px 0 15px 0;font-size:14px;&quot;&gt;\r\n                Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; colspan=&quot;2&quot; style=&quot;padding:0;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;background:#62bc0f;&quot; valign=&quot;middle&quot;&gt;\r\n              &lt;td&gt;\r\n                &lt;div style=&quot;font-size:20px;font-weight:bold;margin-top:20px;color:#fff;margin-left:10px;&quot;&gt;\r\n                  Название магазина&lt;/div&gt;\r\n                &lt;div style=&quot;color:#fff;text-decoration:none;margin-left:10px;margin-bottom:20px;&quot;&gt;\r\n                        &lt;/td&gt;\r\n              &lt;td style=&quot;text-align:right;padding-right:10px;&quot;&gt;\r\n                &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/tech/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt;&lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/tech/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr style=&quot;text-decoration:none;font-size:12px;&quot;&gt;\r\n              &lt;td colspan=&quot;2&quot; style=&quot;color:#138ca9;text-align:right;padding:10px 0;&quot;&gt;\r\n                     Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;color:#138ca9;text-decoration:underline;&quot;&gt;по ссылке.&lt;/a&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

            $ne_template_data_db = <<<TEMPLATEDATADB
INSERT INTO `ne_template_data` (`template_data_id`, `template_id`, `language_id`, `subject`, `body`, `defined`, `special`, `latest`, `popular`, `categories`, `savings`) VALUES
(NULL, 11, {language_id}, 'Тема вашей рассылки', '&lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;font-family:Arial,Helvetica,sans-serif;font-size:13px;color:rgb(130,130,130);background:#fff;padding:0 10px;&quot; width=&quot;100%&quot;&gt;\r\n  &lt;tbody&gt;\r\n    &lt;tr&gt;\r\n      &lt;td&gt;\r\n        &lt;table align=&quot;center&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; style=&quot;background:#fff;&quot; width=&quot;750&quot;&gt;\r\n          &lt;tbody&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:11px;padding-top:10px;padding-right:0px;padding-bottom:10px;padding-left:28px;text-align:right;color:#717171;&quot;&gt;\r\n                Если у вас возникают проблемы при просмотре этого письма,&amp;nbsp;&lt;a href=&quot;{show_url}&quot; style=&quot;text-decoration:underline;color:#717171;&quot;&gt;откройте его веб-версию&lt;/a&gt;.&lt;br /&gt;&lt;br /&gt;{language}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td align=&quot;left&quot; style=&quot;padding-top:24px;padding-right:0px;padding-bottom:10px;padding-left:28px;&quot; valign=&quot;top&quot;&gt;\r\n                        {logo}&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-top:20px;padding-right:28px;padding-bottom:0px;padding-left:0px;&quot; valign=&quot;top&quot;&gt;\r\n                        &lt;div style=&quot;font-size:18px;color:#a0aa08;&quot;&gt;\r\n                          {date}&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;color:#f39a1a;font-weight:bold;padding:10px 0;&quot;&gt;\r\n                        Рассылка магазина&lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot;&gt;\r\n                        &lt;div style=&quot;font-size:11px;color:#333;&quot;&gt;\r\n                          &lt;a href=&quot;{subscribe_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Подписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Отписаться&lt;/a&gt;&amp;nbsp;|&amp;nbsp;&lt;a href=&quot;{store_url}&quot; style=&quot;text-decoration:none;color:#717171;&quot;&gt;Откройте наш сайт&lt;/a&gt;&lt;/div&gt;\r\n                      &lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/thanksgiving/images/header.jpg&quot; width=&quot;100%&quot; /&gt;&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;padding-top:10px;padding-bottom:20px;font-size:14px;color:#000;padding-left:10px;&quot;&gt;\r\n                &lt;strong&gt;Lorem Ipsum&lt;/strong&gt; is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry&quote;s standard dummy text ever since the 1500s, when an unknown printer took a galley of type.&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fafbf5;&quot;&gt;\r\n                {defined}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fafbf5;&quot;&gt;\r\n                {special}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fafbf5;&quot;&gt;\r\n                {latest}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fafbf5;&quot;&gt;\r\n                {popular}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td align=&quot;center&quot; style=&quot;padding:0;background:#fafbf5;&quot;&gt;\r\n                {categories}&lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td width=&quot;750&quot;&gt;\r\n                &lt;table cellpadding=&quot;0&quot; cellspacing=&quot;0&quot; width=&quot;100%&quot;&gt;\r\n                  &lt;tbody&gt;\r\n                    &lt;tr&gt;\r\n                      &lt;td style=&quot;padding-top:10px;&quot;&gt;\r\n                        &lt;p style=&quot;color:#80880a;font-weight:bold;font-size:18px;margin-bottom:5px;margin-top:0;&quot;&gt;\r\n                          Название магазина&lt;/p&gt;\r\n                        &lt;div style=&quot;font-size:14px;padding-bottom:0px;&quot;&gt;\r\n                                              &lt;/td&gt;\r\n                      &lt;td align=&quot;right&quot; style=&quot;padding-right:10px;padding-top:0px;&quot;&gt;\r\n                        &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/thanksgiving/images/f.png&quot; style=&quot;margin-right:10px;&quot; /&gt;&lt;/a&gt; &lt;a href=&quot;#&quot;&gt;&lt;img src=&quot;{HTTP_CATALOG}catalog/view/theme/default/template/ne/templates/thanksgiving/images/t.png&quot; /&gt;&lt;/a&gt;&lt;/td&gt;\r\n                    &lt;/tr&gt;\r\n                  &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n            &lt;tr&gt;\r\n              &lt;td style=&quot;font-size:12px;text-align:left;padding:10px 0;background:none;color:#b4b4b4;&quot;&gt;\r\n                &lt;p style=&quot;margin:0;&quot;&gt;\r\n                           &lt;p style=&quot;margin:0;&quot;&gt;\r\n                  Если вы больше не хотите получать нашу рассылку - отпишитесь &lt;a href=&quot;{unsubscribe_url}&quot; style=&quot;text-decoration:underline;color:#b4b4b4;&quot;&gt;по ссылке&lt;/a&gt;.&lt;/p&gt;\r\n              &lt;/td&gt;\r\n            &lt;/tr&gt;\r\n          &lt;/tbody&gt;\r\n        &lt;/table&gt;\r\n      &lt;/td&gt;\r\n    &lt;/tr&gt;\r\n  &lt;/tbody&gt;\r\n&lt;/table&gt;\r\n', 'Наши товары', 'Товары со скидками', 'Новые товары', 'Популярные товары', 'Категория: %s', 'Скидка %s%%');
TEMPLATEDATADB;

            $ne_template_data_db = str_replace('{HTTP_CATALOG}', $store_url, $ne_template_data_db);
            $ne_template_data_db = str_replace('{language_id}', (int)$language['language_id'], $ne_template_data_db);
            $this->db->query(str_replace('ne_template_data', DB_PREFIX . 'ne_template_data', $ne_template_data_db));

        }

    }

    public function uninstall()
    {
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_language_map`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_clicks`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_draft`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_history`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_marketing`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_marketing_to_list`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_queue`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_schedule`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_stats`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_stats_personal`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_stats_personal_views`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_template`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_template_data`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_blacklist`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "ne_subscribe_box`;");
    }

    public function editSettingValue($code = '', $key = '', $value = '', $store_id = 0)
    {
        if (version_compare(VERSION, '2.0.0.0', '>')) {
            $code_column = 'code';
        } else {
            $code_column = 'group';
        }

        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "setting WHERE store_id = '" . (int)$store_id . "' AND `" . $code_column . "` = '" . $this->db->escape($code) . "' AND `key` = '" . $this->db->escape($key) . "'");
        $setting_info = $query->row;
        $serialized = ", serialized = '%s'";
        if ($setting_info) {
            if (!is_array($value)) {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape($value) . "'" . sprintf($serialized, 0) . " WHERE `" . $code_column . "` = '" . $this->db->escape($code) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            } else {
                $this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = '" . $this->db->escape(serialize($value)) . "'" . sprintf($serialized, 1) . " WHERE `" . $code_column . "` = '" . $this->db->escape($code) . "' AND `key` = '" . $this->db->escape($key) . "' AND store_id = '" . (int)$store_id . "'");
            }
        } else {
            if (!is_array($value)) {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `" . $code_column . "` = '" . $this->db->escape($code) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape($value) . "'");
            } else {
                $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '" . (int)$store_id . "', `" . $code_column . "` = '" . $this->db->escape($code) . "', `key` = '" . $this->db->escape($key) . "', `value` = '" . $this->db->escape(serialize($value)) . "'" . sprintf($serialized, 1) . "");
            }
        }
    }

}